
//Title:        MiniTeller
//Version:      
//Copyright:    Copyright (c) 1998
//Author:       Nicholas Riley
//Company:      Brandeis University
//Description:  A small bank implementation

package miniteller;

import java.awt.*;
import java.awt.event.*;
import com.sun.java.swing.*;
import borland.jbcl.layout.*;
import org.omg.CORBA.FloatHolder;

class OpPanel extends JPanel implements ActionListener {
  JLabel amtLabel = new JLabel();
  JTextField amtField = new JTextField();
  GridBagLayout gridBagLayout1 = new GridBagLayout();

  AcctOpsFrame aof;

  String actionStr = "Transfer";
  String prepStr = "from";
  int op;
  JLabel xAcctLabel = new JLabel();
  JLabel completeLabel = new JLabel();
  JLabel balLabel = new JLabel();
  JTextField balField = new JTextField();
  JTextField balField2 = new JTextField();
  JLabel transLabel1 = new JLabel();
  JLabel transLabel2 = new JLabel();
  JLabel acctLabel = new JLabel();
  JTextField acctField = new JTextField();
  JButton actButton = new JButton();

  Account dest; // used for transfer
  Float destbal;

  float amt;

  public OpPanel(int opType, String action, String preposition,
                 AcctOpsFrame parent) {
    this.op = opType;
    this.actionStr = action;
    this.prepStr = preposition;
    this.aof = parent;
    try  {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  protected OpPanel() {
    this(AcctOpsFrame.OP_DEPOSIT, "Deposit", "into", null);
  }

  void jbInit() throws Exception {
    amtLabel.setText(actionStr + " $");
    amtLabel.setHorizontalAlignment(SwingConstants.RIGHT);
    amtField.setColumns(7);
    amtField.setHorizontalAlignment(JTextField.RIGHT);
    xAcctLabel.setText(prepStr + " your account");
    balLabel.setText("your account balance will be $");
    balLabel.setHorizontalAlignment(SwingConstants.RIGHT);
    balField.setColumns(9);
    balField.setText("<unimplemented>");
    balField.setHorizontalAlignment(JTextField.RIGHT);
    balField.setBackground(SystemColor.control);
    balField.setEditable(false);
    if (op == AcctOpsFrame.OP_TRANSFER) {
      balField2.setColumns(9);
      balField2.setHorizontalAlignment(JTextField.RIGHT);
      balField2.setBackground(SystemColor.control);
      balField2.setEditable(false);
      balField2.setText("<unimplemented>");
      acctLabel.setText("into the account numbered");
      acctLabel.setHorizontalAlignment(JTextField.RIGHT);
      acctField.setColumns(5);
      acctField.setHorizontalAlignment(JTextField.RIGHT);
      transLabel1.setText("and the balance of the transfer");
      transLabel1.setHorizontalAlignment(SwingConstants.RIGHT);
      transLabel2.setText("destination account will be $");
      transLabel2.setHorizontalAlignment(SwingConstants.RIGHT);
    }
    actButton.setText(actionStr);
    actButton.addActionListener(this);
    completeLabel.setText("After completing this transaction,");
    completeLabel.setFont(new Font("Dialog", 1, 12));
    this.setLayout(gridBagLayout1);
    this.add(amtLabel, new GridBagConstraints2(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.HORIZONTAL, new Insets(0, 10, 0, 0), 0, 0));
    this.add(amtField, new GridBagConstraints2(1, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
    this.add(xAcctLabel, new GridBagConstraints2(2, 0, 2, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 10), 0, 0));
    this.add(completeLabel, new GridBagConstraints2(0, 2, 3, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(10, 10, 0, 10), 0, 0));
    this.add(balLabel, new GridBagConstraints2(0, 3, 3, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.HORIZONTAL, new Insets(5, 10, 5, 0), 0, 0));
    this.add(balField, new GridBagConstraints2(3, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 10), 0, 0));
    if (op == AcctOpsFrame.OP_TRANSFER) {
      this.add(acctLabel, new GridBagConstraints2(0, 1, 3, 1, 0.0, 0.0
              ,GridBagConstraints.EAST, GridBagConstraints.HORIZONTAL, new Insets(0, 10, 0, 0), 0, 0));
      this.add(acctField, new GridBagConstraints2(3, 1, 1, 1, 0.0, 0.0
              ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
      this.add(transLabel1, new GridBagConstraints2(0, 4, 3, 1, 0.0, 0.0
              ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
      this.add(transLabel2, new GridBagConstraints2(0, 5, 3, 1, 0.0, 0.0
              ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 0, 5, 0), 0, 0));
      this.add(balField2, new GridBagConstraints2(3, 4, 1, 2, 0.0, 0.0
              ,GridBagConstraints.SOUTH, GridBagConstraints.NONE, new Insets(0, 5, 5, 10), 0, 0));
    }
    this.add(actButton, new GridBagConstraints2(0, 6, 5, 1, 0.0, 1.0
            ,GridBagConstraints.SOUTH, GridBagConstraints.NONE, new Insets(15, 10, 10, 10), 0, 0));
  }

  protected boolean getDest() {
    if (op != AcctOpsFrame.OP_TRANSFER) return false;
    try {
    dest = aof.mt.getAccount(Integer.parseInt(acctField.getText()));
    destbal = new Float(dest.getBalance());
    } catch (AccessViolation ae) {
      new ErrorDialog(aof, ae);
      return false;
    } catch (NumberFormatException fe) {
      new ErrorDialog(aof, new DataInvalid(
        "Destination account number in wrong format - please try again."));
      return false;
    }
    return true;
  }

  protected boolean getAmt() {
    try {
    amt = Float.valueOf(amtField.getText()).floatValue();
		if (amt == Float.POSITIVE_INFINITY) {
			new ErrorDialog(aof, new DataInvalid(
				"Specified amount is too large - please try again."));
			return false;
		}
    } catch (NumberFormatException e) { // take out if preview works
      new ErrorDialog(aof, new DataInvalid(
        "Specified amount is not a number in the form xxx[.yy], e.g. 139.30."));
      return false;
    }
    return true;
    // actButton.setEnabled(getAmt()); *** when I get time
  }

  public void actionPerformed(ActionEvent ev) {
    // (try to) get amount
    if (!getAmt()) return;
    // perform operation
    try {
    if (op == AcctOpsFrame.OP_TRANSFER) {
      if (!getDest()) return;
      FloatHolder ndbalHolder = new FloatHolder();
      synchronized (aof.bal) {
        aof.bal = new Float(aof.acct.transfer(amt, dest, ndbalHolder));
        destbal = new Float(ndbalHolder.value);
      }
    } else {
      synchronized (aof.bal) {
        if (op == AcctOpsFrame.OP_DEPOSIT)
          aof.bal = new Float(aof.acct.deposit(amt));
        else if (op == AcctOpsFrame.OP_WITHDRAW)
          aof.bal = new Float(aof.acct.withdraw(amt));
        else {
          new ErrorDialog(aof, new AccessViolation(
            "Unsupported account operation."));
          return;
        }
      } // synchronized
    } // if transfer
    } catch (DataInvalid die) { new ErrorDialog(aof, die); return; }
      catch (AccessViolation ave) { new ErrorDialog(aof, ave); return; }
      catch (InsufficientFunds ife) { new ErrorDialog(aof, ife); return; }

    // notification
    try {
    String[][] mes;
    String[] binfo = aof.acct.getBasicInfo();
    amtField.setText("");
    if (op == AcctOpsFrame.OP_TRANSFER) {
      acctField.setText("");
      String[] dinfo = dest.getBasicInfo();
      mes = new String[][]
        {{"New balance of source account " + binfo[Account.bidx_acct] + ":",
          binfo[Account.bidx_bal]},
         {"New balance of destination account " + dinfo[Account.bidx_acct] + ":",
          dinfo[Account.bidx_bal]}};
    } else
      mes = new String[][]
        {{"New balance of account " + binfo[Account.bidx_acct] + ":",
          binfo[Account.bidx_bal]}};
    new NotifyDialog(aof, actionStr + " successfully performed.",
                     mes);
    } catch (AccessViolation e) {
      e.explanation = actionStr + " successfully performed. " + e.explanation;
      new ErrorDialog(aof, e);
    }
  }
}
